//! # Admin account key helper
//!
//! @author Pierre Hubert

use webauthn_rs::proto::Credential;

use crate::constants::database_tables_names::ADMIN_KEYS_TABLE;
use crate::data::admin::AdminID;
use crate::data::error::Res;
use crate::helpers::database;
use crate::utils::date_utils::time;

/// Save a new key in the database
pub fn add_key(id: AdminID, name: &str, key: Credential) -> Res {
    database::InsertQuery::new(ADMIN_KEYS_TABLE)
        .add_admin_id("admin_id", id)
        .add_str("name", name)
        .add_u64("time_add", time())
        .add_str("security_key", &serde_json::to_string(&key)?)
        .insert_drop_result()
}